/*
  Library support for FlexRadio 6000 Rigs
  Copyright (C)2015 Vincenzo Stefanazzi - IW7DMH. All right reserved

  This library is free software; you can redistribute it and/or
  modify it under the terms of the CC BY-NC-SA 3.0 license.
  https://creativecommons.org/licenses/by-nc-sa/3.0/
  
  The license applies to all part of the library including the 
  examples and tools supplied with the library.
*/
#ifndef Panadapter_h
#define Panadapter_h
#include "Arduino.h"

#define PANADAPTER_AVERAGE 5000
#define PANADAPTER_FPS 5001
#define PAN_BANDWIDTH 5002
#define PAN_MIN_DBM 5003
#define PAN_MAX_DBM 5004

class Panadapter
{
  public:
    //properties
	int pan; // 0x40000000 
	int x_pixels; //=1170 
	int y_pixels; //=187 
	int center; //=14.033201 
	int bandwidth; //=0.210171 
	int min_dbm; //=-125 
	int max_dbm; //=-40 
	int fps; //=25
	int average; //=10 
	int weighted_average; //=0 
	int rfgain; //=0 
	String rxant; //=ANT1 
	int wide; //=0 
	int loopa; //=0 
	int loopb; //=0 
	int band; //=20 
	int daxiq; //=1 
	int daxiq_rate; //=48000 
	int capacity; //=16 
	int available; //=14 
	int waterfall; //=42000000 
	double min_bw; //=0.004919999957085
	double max_bw; //=7.372800292969 
	int xvtr; //= 
	int pre; //= 
	String ant_list; //=ANT1,ANT2,XVTR


    //methods
    Panadapter();
	void updateStatus(String msg);
	void updateObject(int objectId,int value);  //Update specific panadapter object	
	boolean updated;
  private:
    //properties
	
    //methods	
	void setValue(String msg);
};
	
#endif