/*
  Library support for FlexRadio 6000 Rigs
  Copyright (C)2015 Vincenzo Stefanazzi - IW7DMH. All right reserved

  This library is free software; you can redistribute it and/or
  modify it under the terms of the CC BY-NC-SA 3.0 license.
  https://creativecommons.org/licenses/by-nc-sa/3.0/
  
  The license applies to all part of the library including the 
  examples and tools supplied with the library.
*/
#ifndef Radio_h
#define Radio_h
#include "Arduino.h"

#define RADIO_MIXER_LINEOUT_GAIN 1000
#define RADIO_MIXER_HEADPHONE_GAIN 1001

class Radio
{
  public:
    //properties
	int slices; //=0 
	int panadapters; //=0 
	int lineout_gain; //=86 
	int lineout_mute; //=0 
	int headphone_gain; //=59 
	int headphone_mute; //=1 
	int remote_on_enabled; //=0
	int pll_done; //=0 
	int freq_error_ppb; //=-1
	int cal_freq; //=15.000
	int tnf_enabled; //=1
	int snap_tune_enabled; //=1
    //methods
    Radio();
	void updateStatus(String msg);  //Update radio objects using status messages 
	void updateObject(int objectId,int value);  //Update specific radio object	
	boolean updated;
  private:
    //properties
	
    //methods
	void setValue(String msg);
	void addToStatusList(int statusId, int statusValue);
};
	
#endif

/* radio - RESPONSE V1.4
S5BD3B994|radio slices=1 
                panadapters=1 
				lineout_gain=64 
				lineout_mute=0 
				headphone_gain=52 
				headphone_mute=1 
				remote_on_enabled=0 
				pll_done=0 
				freq_error_ppb=-1 
				cal_freq=15.000 
				tnf_enabled=1 
				snap_tune_enabled=1 
				nickname=A201440250079 
				callsign=IW7DMH
*/