/*
  Library support for FlexRadio 6000 Rigs
  Copyright (C)2015 Vincenzo Stefanazzi - IW7DMH. All right reserved

  This library is free software; you can redistribute it and/or
  modify it under the terms of the CC BY-NC-SA 3.0 license.
  https://creativecommons.org/licenses/by-nc-sa/3.0/
  
  The license applies to all part of the library including the 
  examples and tools supplied with the library.
*/
#include "Transmit.h"
Transmit::Transmit() {
	updated=false;
}

void Transmit::updateStatus(String msg) {

	//Serial.println(msg);
	updated=true;
	int oldi=0;
	int i=msg.indexOf(' ',oldi);
	while (i>0) {
		setValue(msg.substring(oldi,i));
		oldi=i+1;
		i=msg.indexOf(' ',oldi+1);
	}
	//get the last element
	i=msg.indexOf('\n',oldi);
	setValue(msg.substring(oldi,i));
	/*	
	Serial.println(freq);			
	Serial.println(lo);			
	Serial.println(hi);			
	Serial.println(rfpower);			
	Serial.println(tunepower);		
	Serial.println(am_carrier_level);	
	Serial.println(vox_enable);		
	Serial.println(vox_level);		
	Serial.println(vox_delay);		
	Serial.println(mic_level);		
	Serial.println(mic_selection);	
	Serial.println(mic_boost);		
	Serial.println(mic_bias);		
	Serial.println(mic_acc);			
	Serial.println(compander);		
	Serial.println(compander_level);		
	Serial.println(dax);			
	Serial.println(pitch);			
	Serial.println(speed);			
	Serial.println(iambic);			
	Serial.println(iambic_mode);		
	Serial.println(cwl_enabled);		
	Serial.println(swap_paddles);		
	Serial.println(break_in);		
	Serial.println(break_in_delay);		
	Serial.println(sidetone);		
	Serial.println(monitor);			
	Serial.println(mon_gain_cw);		
	Serial.println(mon_gain_sb);		
	Serial.println(mon_pan_cw);		
	Serial.println(mon_pan_sb);		
	Serial.println(tune);			
	Serial.println(met_in_rx);		
	Serial.println(hwalc_enabled);		
	Serial.println(inhibit);			
	Serial.println(speech_processor_enable);	
	Serial.println(speech_processor_level);	
	Serial.println(show_tx_in_waterfall);	
	*/

}

void Transmit::setValue(String msg){
	int i=msg.indexOf('=');
	if (i>0) {
	    String var=msg.substring(0,i);
		//Serial.print(var); Serial.print("=");Serial.println(msg.substring(i+1));
		if (var.equals("freq")) { freq=msg.substring(i+1).toFloat()*1000000; return; }
		if (var.equals("lo")) { lo=msg.substring(i+1).toInt(); return; }
        if (var.equals("hi")) { hi=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("rfpower")) { rfpower=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("tunepower")) { tunepower=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("am_carrier_level")) { am_carrier_level=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("vox_enable")) { vox_enable=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("vox_level")) { vox_level=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("vox_delay")) { vox_delay=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("mic_level")) { mic_level=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("mic_selection")) { mic_selection=msg.substring(i+1); return; } 	
        if (var.equals("mic_boost")) { mic_boost=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("mic_bias")) { mic_bias=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("mic_acc")) { mic_acc=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("compander")) { compander=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("compander_level")) { compander_level=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("dax")) { dax=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("pitch")) { pitch=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("speed")) { speed=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("iambic")) { iambic=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("iambic_mode")) { iambic_mode=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("cwl_enabled")) { cwl_enabled=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("swap_paddles")) { swap_paddles=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("break_in")) { break_in=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("break_in_delay")) { break_in_delay=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("sidetone")) { sidetone=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("monitor")) { monitor=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("mon_gain_cw")) { mon_gain_cw=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("mon_gain_sb")) { mon_gain_sb=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("mon_pan_cw")) { mon_pan_cw=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("mon_pan_sb")) { mon_pan_sb=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("tune")) { tune=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("met_in_rx")) { met_in_rx=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("hwalc_enabled")) { hwalc_enabled=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("inhibit")) { inhibit=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("speech_processor_enable")) { speech_processor_enable=msg.substring(i+1).toInt(); return; } 	
        if (var.equals("speech_processor_level")) { speech_processor_level=msg.substring(i+1).toInt(); return;  }	
        if (var.equals("show_tx_in_waterfall")) { show_tx_in_waterfall=msg.substring(i+1).toInt(); return;  }	

	}
}

void Transmit::updateObject(int objectId,int value){
	switch(objectId) {
		case TRANSMIT_RF_POWER:
			 rfpower=value;
			 break;
		case TRANSMIT_ATU_POWER:
			 tunepower=value;
			 break;
		case TRANSMIT_BREAK_IN_DELAY:
			 break_in_delay=value;
			 break;
		case TRANSMIT_MONITOR_GAIN_CW:
			 mon_gain_cw=value;
			 break;
		case TRANSMIT_MONITOR_PAN_CW:
			 mon_pan_cw=value;
			 break;
		case TRANSMIT_SPEED:
			 speed=value;
			 break;
		case TRANSMIT_PITCH:
			 pitch=value;
			 break;
		case TRANSMIT_MIC_LEVEL:
			 mic_level=value;
			 break;
		case TRANSMIT_MONITOR_GAIN_SB:
			 mon_gain_sb=value;
			 break;
		case TRANSMIT_COMPANDER_LEVEL:
			 compander_level=value;
			 break;	 
		case TRANSMIT_VOX_LEVEL:
			 vox_level=value;
			 break;	 
		case TRANSMIT_VOX_DELAY:
			 vox_delay=value;
			 break;	 
		case TRANSMIT_AM_CARRIER:
			 am_carrier_level=value;
			 break;
		case TRANSMIT_LO:
			 lo=value;
			 break;
		case TRANSMIT_HI:
			 hi=value;
			 break;	 
		default:
			 Serial.print("Transmit::updateObject - Unhandled id:"); Serial.println(objectId);
	}
	
}